// 匹配规则
interface Rule {
  type: string,
  value: string
}

// 监听选项
// filepath 监听文件夹路径,也用于匹配要编译的文件
// recursive 开启监听所以子孙目录
interface WatchOptions {
  filepath: string,
  recursive: boolean
}

// 编译选项
interface CompileOptions {
  type: string,
  ext: string,
  includes: string | Rule | Array<Rule>,
  excludes: string | Rule | Array<Rule>,
  sourceMap: boolean
}

// 服务配置
interface ServiceOptions {
  openWatch: boolean, // 开启监听
  watch: WatchOptions,
  compile: CompileOptions
}

declare function createService (options: ServiceOptions | string): void