

import {
  formatRules,
  Rule,
  RuleType
} from '../rule'



const rules1 = 'aaa'
test(
  `original value: ${rules1} \n\t expected value: ${JSON.stringify([{ type: RuleType.SUFFIX, value: rules1 }])}`,
  () => {
    expect(formatRules(rules1)).toEqual([{ type: RuleType.SUFFIX, value: rules1 }])
  }
)

const rules2 = { type: RuleType.SUFFIX, value: 'rules' }
test(
  `original value: ${JSON.stringify(rules2)} \n\t expected value: ${JSON.stringify([rules2])}`,
  () => {
    expect(formatRules(rules2)).toEqual([rules2])
  }
)

const rules3 = []
test(
  `original value: ${JSON.stringify(rules3)} \n\t expected value: ${JSON.stringify([])}`,
  () => {
    expect(formatRules(rules3)).toEqual([])
  }
)


const rules4 = ['r4', {type: RuleType.FILE, value: 'file'}, null, { type: RuleType.PREFIX }, { value: '1111' }]
test(
  `original value: ${JSON.stringify(rules4)} \n\t expected value: ${JSON.stringify([{type: RuleType.SUFFIX, value: 'r4'},{type: RuleType.FILE, value: 'file'}])}`,
  () => {
    expect(formatRules(rules4 as Array<Rule>)).toEqual([{type: RuleType.SUFFIX, value: 'r4'},{type: RuleType.FILE, value: 'file'}])
  }
)


const rules5 = null
const expectedValue = []
test(
  `original value: null \n\t expected value: ${JSON.stringify(expectedValue)}`,
  () => {
    expect(formatRules(rules5)).toEqual(expectedValue)
  }
)


const rules6 = {}
const expectedValue1 = []
test(
  `original value: null \n\t expected value: ${JSON.stringify(expectedValue1)}`,
  () => {
    expect(formatRules(rules6 as Rule)).toEqual(expectedValue1)
  }
)

const rules7 = { type: RuleType.FILE, value: '/test/nithh' }
const expectedValue2 = [{ type: RuleType.FILE, value: 'test\\nithh' }]
test(
  `original value: ${JSON.stringify(rules7)} \n\t expected value: ${JSON.stringify(expectedValue2)}`,
  () => {
    expect(formatRules(rules7 as Rule)).toEqual(expectedValue2)
  }
)


const rules8 = { type: RuleType.FILE, value: 'test///aa' }
const expectedValue3 = [{ type: RuleType.FILE, value: 'test\\aa' }]
test(
  `original value: ${JSON.stringify(rules7)} \n\t expected value: ${JSON.stringify(expectedValue3)}`,
  () => {
    expect(formatRules(rules8 as Rule)).toEqual(expectedValue3)
  }
)